#include <LiquidCrystal.h>
// initialize the library with the numbers of the interface pins
LiquidCrystal lcd(12, 11, 5, 4, 3, 2); 

// CONSTANTES para el tiempo del reloj
int TIEMPO = 1; //tiempo principal (minutos)
int BYO_YOMI = 10; //tiempo del byo yomi (segundos)
int BYO_VECES = 5; //numero de byo_yomi
int BEEPBYO = 5;

//VARIABLES
int estado = 0;
int numJ = 0;
long t1, m1, s1, t2, m2, s2, aux1, aux2;
int byo1, byo2 = 0;
int byoNum1 = BYO_VECES, byoNum2 = BYO_VECES;
long tPerdido = 0;
int BoW = 0; // BlackOrWhite: 0 nada, 1 Black, 2 White

int boton = 8;
int led = 13;
int speaker = 10;


void setup() {
    pinMode(boton, INPUT);
    pinMode(speaker, OUTPUT);
    pinMode(led, OUTPUT);
    
    digitalWrite(led,HIGH);
    // set up the LCD's number of columns and rows:
    lcd.begin(16, 2);
    // Print a message to the LCD.
    lcd.print("Sencillo Reloj");
    Serial.begin(9600);
}

String parsear(long num){ 
    if (num >= 10)
        return String(num);
    else if (num < 10 && num >= 0)
        return "0" + String(num);
    else
        return "Error";
}

void loop() {
    cont += cont;
    estado = digitalRead(boton);
    // Si esta pulsado el boton esperamos a que se deje de pulsar para contar la pulsacion
    if (estado == HIGH){
        while (estado == HIGH){
            estado = digitalRead(boton);
            if (estado == LOW){
                Serial.println("Pulsado");
                break;
            }
        }
        
        // seleccionamos el color del jugador
        if (BoW == 1){BoW = 2;}
        else if (BoW == 2){BoW = 1;}
        else if (BoW == 0){BoW = 1;}
        numJ += 1;
    }
    
      
    //TIEMPO DE NEGRO
    else if (BoW == 1 && byo1 == 0 && estado == LOW){
        t1 =  long(millis()/1000) - t2 - tPerdido;
        m1 = (TIEMPO*60-t1)/60;
        s1 = (TIEMPO*60-t1)%60;
        //Comprobamos que ha terminado el tiempo principal del jugador
        if (m1 <= 0 && s1 <= 0){ // activar byo yomi
            byo1 = 1;
            //Pitamos por que entramos en el Byo yomi
            tone(speaker, 200, 500);
            aux1 = long(millis()/1000) - t2 - tPerdido;
            
            
        }
    }
    // BYO YOMI DE NEGRO
    else if (BoW == 1 && byo1 == 1 && estado == LOW){
        t1 =  long(millis()/1000) - t2 - tPerdido;
        m1 = (BYO_YOMI - (t1 - aux1))/60;
        s1 = (BYO_YOMI - (t1 - aux1))%60;
        //Escribimos que estamos en byo y cuantos quedan en la parte de arriba
        lcd.setCursor(0,0);
        lcd.print("byo B:");
        lcd.print(byoNum1);
        lcd.print("  ");
        //Pitamos por que nos queda BEEPBYO en el Byo yomi
        if(m1 == 0 && s1 <= BEEPBYO)
            tone(speaker, 200, 300);
        else
            digitalWrite(speaker, LOW);
            
        if(m1 <= 0 && s1 <= 0){ // quitar un byo yomi y ponerlo al tiempo correspondiente
            byoNum1 -= 1;
            aux1 = long(millis()/1000) - t2 - tPerdido;
            if (byoNum1 <= 0){
                while (1){
                    lcd.setCursor(0, 0);
                    lcd.print("  Negro Tiempo   ");
                }
            }
        }
    }
    
    // TIEMPO DE BLANCO
    else if (BoW == 2 && byo2 == 0 && estado == LOW){
        t2 = long(millis()/1000) - t1 - tPerdido;
        m2 = (TIEMPO*60-t2)/60;
        s2 = (TIEMPO*60-t2)%60;
        //Comprobamos que ha terminado el tiempo del jugador
        if (m2 <= 0 && s2 <= 0){ // activar byo yomi
            byo2 = 1;
            //Pitamos por que entramos en el Byo yomi
            tone(speaker, 200, 500);
            aux2 = long(millis()/1000) - t1 - tPerdido;
        }
    }
    // BYO YOMI DE BLANCO
    else if (BoW == 2 && byo2 == 1 && estado == LOW){
        t2 =  long(millis()/1000) - t1 - tPerdido;
        m2 = (BYO_YOMI - (t2 - aux2))/60;
        s2 = (BYO_YOMI - (t2 - aux2))%60;
        //Escribimos que estamos en byo y cuantos quedan en la parte de arriba
        lcd.setCursor(7,0);
        lcd.print("  ");
        lcd.print("byo W:");
        lcd.print(byoNum2);
        
        // Empezamos a pitar cuando falten BEEPBYO segundos
        if(m2 == 0 && s2 <= BEEPBYO)
            tone(speaker, 200, 300);
        else
            digitalWrite(speaker, LOW);
        
        if(m2 <= 0 && s2 <= 0){ // quitar un byo yomi y ponerlo al tiempo correspondiente
            byoNum2 = byoNum2 - 1;
            aux2 = long(millis()/1000) - t1 - tPerdido;
            if (byoNum2 <= 0){
                while (1){
                    lcd.setCursor(0, 0);
                    lcd.print(" Blanco Tiempo ");
                }
            }
        }
    }
    
    else
        tPerdido = long(millis()/1000);
    
    
    //Imprimimos en lcd el tiempo de J1
    lcd.setCursor(0, 1);
    lcd.print(parsear(m1));
    lcd.print(":");
    lcd.print(parsear(s1));
    
    //Imprimimos en pantalla el numero de jugada
    lcd.setCursor(7,1);
    lcd.print(numJ);
    
    //Imprimimos en lcd el tiempo de J2 
    lcd.setCursor(11, 1);
    lcd.print(parsear(m2));
    lcd.print(":");
    lcd.print(parsear(s2));
    
    
}
