#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#    check_stone.py
#       
#    Copyright 2010 Victor Ramirez <virako.9@gmail.com>
#       
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


from cte import *


def check_stone(tablero, p, color): # la piedra puesta tiene que contenerla, pero no hace falta comprobarla
    """Funcion recursiva que comprueba si la piedra pasada por parámetro está 
       muerta o esta viva. Ver reglas del go para más detalles. """
    x = p[0]
    y = p[1]
    
    # Recogemos los colores que tenemos alrededor, si no hay punto estamos en el borde y devolvemos True
    
    # Comprobamos que color tenemos y hacemos su funcion
    # Si es del mismo color, recursividad
    # si es de distinto color, True
    # Si está libre, False y nos salimos, la piedra no nos sirve
    
    all_pos = ((0, -1), (0, 1), (-1, 0), (1, 0)) # u, d, l, r
    bool_stone = True
    
    for pos in all_pos:
        try: 
            c = tablero.matriz[x - pos[0]][y - pos[1]][3]
            if c == SPACE:
                bool_stone = False
                break
            elif c != color:
                new_p = (p[0] - pos[0], p[1] - pos[0])
                check_stone(tablero, new_p, color)
        
        except IndexError:
            bool_stone = False
            break
    
    return bool_stone
    
    """
    try:
        u = self.tablero.matriz[x][y][3]
        if u == color:
            bool_u = True
        elif (u == SPACE):
            bool_u = False
            return False
        else:
            new_p = (p[0], p[1]-1)
            check_stone(new_p, color)
    except: # La excepción será si sale de rango la matriz
        bool_u = True

    try:
        d = self.tablero.matriz[x][y][3]
        if d == color:
            bool_d = True
        elif d ==  SPACE:
            bool_d = False
            return False
        else:
            new_p = (p[0], p[1]-1)
            check_stone(new_p, color)
    except:
        bool_d = True

    try:
        l = self.tablero.matriz[x][y][3]
        if l == color:
            bool_l = True
        elif l == SPACE:
            bool_l = False
            return False
        else:
            new_p = (p[0], p[1]-1)
            check_stone(new_p, color)
    except:
        bool_l = True

    try:
        r = self.tablero.matriz[x][y][3]
        if r == color:
            bool_r = True
        elif r == SPACE:
            bool_r = False
            return False
        else:
            new_p = (p[0], p[1]-1)
            check_stone(new_p, color)
    except:
        bool_r = True
    
    
    # TODO creo que cuando encuentra uno falso no se sale directamente ...
    return bool_u * bool_d * bool_l * bool_r
    """

