#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#       Create_sgf.py
#       
#       Copyright 2010 Victor Ramirez <virako.9@gmail.com>
#       
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

import cte 

class Create_sgf:
    """Clase que nos genera un archivo de extensión .sgf con una cabezera 
       predeterminada para guardar la partida que estamos capturando. """
    def __init__(self, path = "sgf"):
        num = 0
        self.path = path
        self.cadena = cte.PLAYER_B + "-" + cte.PLAYER_W
        name = self.cadena
        try: 
            while 1:
                file = open("%s/%s.sgf" %(self.path, self.cadena), "r") # TODO existe el archivo
                file.close()
                num += 1                
                self.cadena = name + "(" + str(num) + ")"
        except IOError:
            file = open("%s/%s.sgf" %(self.path, self.cadena), "w")
            for elem in cte.INITSGF:
                file.write(elem)
            file.close()    
            
    def add_text(self, text, color):
        file = open("%s/%s.sgf" %(self.path, self.cadena), "a")
        if color == cte.BLACK:
            file.write("\n;B[%s]" %text)
        elif color == cte.WHITE:
            file.write("\n;W[%s]" %text)
        else:
            print "el color debe ser BLACK or WHITE"
        file.close()
        
    def end_file(self):
        file = open("%s/%s.sgf" %(self.path, self.cadena), "a")
        file.write("))")
        file.close()
    
